
-- # import id

data Bool : Set where
  false	: Bool
  true	: Bool

if (A : Set) : Bool -> A -> A -> A
if false x y = y
if true  x y = x

if' : (C : Bool -> Set) -> (x : Bool) -> C true -> C false -> C x
if' C false x y = y
if' C true  x y = x

data AnalysedBool (b : Bool) : Set where
  itsTrue  : b == true  -> AnalysedBool b
  itsFalse : b == false -> AnalysedBool b

analyseBool : (b : Bool) -> AnalysedBool b
analyseBool true  = itsTrue refl
analyseBool false = itsFalse refl

