
-- # import Set
-- # import Rel

infixl 1 >>>>, >>>
infix 2 `since`

data Chain {A : SET}(R : TransitiveRel A) : El A -> El A -> Prop where
  (>>>>) (b : El A) : (a : El A) -> Prf (R.rel a b) -> Chain R a b
  (>>>)  (a,b,c : El A) : Chain R a b -> Prf (R.rel b c) -> Chain R a c

since (A : SET)(R : TransitiveRel A)(a : El A) :
  (b : El A) -> Prf (R.rel a b) -> Prf (R.rel a b)
since _ p = p

chainReasoning (A : SET)(R : TransitiveRel A)(a,b : El A) :
  Chain R a b -> Prf (R.rel a b)
chainReasoning {A} (a >>>> p) = p
chainReasoning {A} (p  >>> q) = transitivity {A} (chainReasoning p) q

