
-- # import Prop
-- # import Order
-- # import Poset
-- # import Operation

sig LUB' {A : Poset}(x, y, z : El A) : Prop where
  upper : Prf (x <= z /\ y <= z)
  least : Prf (ForAll $ \w -> x <= w /\ y <= w ==> z <= w)

LUB (A : Poset) : El A -> El A -> El A -> PROP
LUB x y z = mkPROP (LUB' x y z)

IsLUB (A : Poset) : BinOp A -> PROP
IsLUB Op = ForAll $ \x -> ForAll $ \y -> LUB x y (Op.op x y)
	    
sig JoinSemiLattice : Type extends Poset where
  join  : el -> el -> el
  islub : Prf (IsLUB (mkBinOp
			{mkPoset (mkSetoid (mkSET el) eq) leq lt}
			join
	      ))

